## ros-iron-joy-linux 3.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(joy_linux)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)
find_package(diagnostic_msgs REQUIRED)
find_package(diagnostic_updater REQUIRED)
find_package(rclcpp REQUIRED)
find_package(sensor_msgs REQUIRED)

# for now, this program only exists for Linux hosts, since it calls into
# the underlying joystick driver provided by the Linux kernel.
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  # Look for <linux/joystick.h>
  include(CheckIncludeFiles)
  check_include_files(linux/joystick.h HAVE_LINUX_JOYSTICK_H)

  if(HAVE_LINUX_JOYSTICK_H)
    include_directories(msg/cpp ${catkin_INCLUDE_DIRS})
    add_executable(joy_linux_node src/joy_linux_node.cpp)
    ament_target_dependencies(joy_linux_node
      "diagnostic_msgs"
      "diagnostic_updater"
      "rclcpp"
      "sensor_msgs")
    install(TARGETS joy_linux_node DESTINATION lib/${PROJECT_NAME})

    if(BUILD_TESTING)
      find_package(ament_lint_auto REQUIRED)
      set(ament_cmake_copyright_FOUND TRUE)
      ament_lint_auto_find_test_dependencies()
    endif()

  else()
    message(FATAL_ERROR "no <linux/joystick.h>; can't build joy node")
  endif()
endif()

ament_package()

=== debian/changelog ===
ros-iron-joy-linux (3.1.0-4jammy) jammy; urgency=high

  * Style fixes for newer cpplint.
  * Contributors: Chris Lalancette

 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 27 Jan 2022 16:00:00 -0000

ros-iron-joy-linux (3.0.1-4jammy) jammy; urgency=high



 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 27 Jan 2022 16:00:00 -0000

ros-iron-joy-linux (3.0.0-4jammy) jammy; urgency=high

  * Update joy_linux_node.cpp (#189 <https://github.com/ros-drivers/joystick_drivers/issues/189>)
  * Reenable diagnostics (#181 <https://github.com/ros-drivers/joystick_drivers/issues/181>)
  * Contributors: Vitaliy Bondar, aaronaaronson98

 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 11 Mar 2021 16:00:00 -0000

ros-iron-joy-linux (2.4.1-4jammy) jammy; urgency=high

  * Small fixes for uncrustify on Foxy. (#171 <https://github.com/ros-drivers/joystick_drivers/issues/171>)
  * Contributors: Chris Lalancette

 -- Chris Lalancette <clalancette@openrobotics.org>  Tue, 12 May 2020 16:00:00 -0000

ros-iron-joy-linux (2.4.0-4jammy) jammy; urgency=high

  * Cross platform joystick support for ROS 2 (#157 <https://github.com/ros-drivers/joystick_drivers/issues/157>)
  * Contributors: Chris Lalancette

 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 11 May 2020 16:00:00 -0000

ros-iron-joy-linux (1.13.0-4jammy) jammy; urgency=high

  * Merge pull request #120 <https://github.com/ros-drivers/joystick_drivers/issues/120> from furushchev/remap
    add joy_remap and its sample
  * Merge pull request #128 <https://github.com/ros-drivers/joystick_drivers/issues/128> from ros-drivers/fix/tab_errors
    Cleaning up Python indentation.
  * Merge pull request #111 <https://github.com/ros-drivers/joystick_drivers/issues/111> from matt-attack/indigo-devel
    Add Basic Force Feedback Support
  * Merge pull request #126 <https://github.com/ros-drivers/joystick_drivers/issues/126> from clalancette/minor-formatting
  * Put brackets around ROS_* macros.
    In some circumstances they may be defined to empty, so we need
    to have brackets to ensure that they are syntactically valid.
    Signed-off-by: Chris Lalancette <mailto:clalancette@openrobotics.org>
  * Merge pull request #122 <https://github.com/ros-drivers/joystick_drivers/issues/122> from lbucklandAS/fix-publish-timestamp
    Add timestamp to all joy messages
  * Change error messages and set ps3 as default controller
  * Better handle device loss
    Allow for loss and redetection of device with force feedback
  * Add basic force feedback over usb
    Addresses #89 <https://github.com/ros-drivers/joystick_drivers/issues/89>
  * Contributors: Chris Lalancette, Furushchev, Joshua Whitley, Lucas Buckland, Matthew, Matthew Bries

 -- Chris Lalancette <clalancette@openrobotics.org>  Sun, 23 Jun 2019 16:00:00 -0000

ros-iron-joy-linux (1.12.0-4jammy) jammy; urgency=high

  * Update timestamp when using autorepeat_rate
  * Added dev_name parameter to select joystick by name
  * Added Readme for joy package with description of new device name parameter
  * Fixed numerous outstanding PRs.
  * Added sticky buttons
  * Changed package xml to format 2
  * Fixed issue when the joystick data did not got send until changed.
  * Changed messaging to better reflect what the script is doing
  * Contributors: Dino Hüllmann, Jonathan Bohren, Joshua Whitley, Miklos Marton, Naoki Mizuno, jprod123, psimona

 -- Chris Lalancette <clalancette@openrobotics.org>  Sun, 10 Jun 2018 16:00:00 -0000

ros-iron-joy-linux (1.11.0-4jammy) jammy; urgency=high

  * fixed joy/Cmakelists for osx
  * Update dependencies to remove warnings
  * Contributors: Marynel Vazquez, Mark D Horn

 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 09 Feb 2017 16:00:00 -0000

ros-iron-joy-linux (1.10.1-4jammy) jammy; urgency=high

  * Remove stray architechture_independent flags
  * Contributors: Jonathan Bohren, Scott K Logan

 -- Chris Lalancette <clalancette@openrobotics.org>  Sat, 23 May 2015 16:00:00 -0000

ros-iron-joy-linux (1.10.0-4jammy) jammy; urgency=high

  * First indigo release

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 25 Jun 2014 16:00:00 -0000

=== debian/control ===
Source: ros-iron-joy-linux
Section: misc
Priority: optional
Maintainer: Chris Lalancette <clalancette@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-iron-ament-cmake, ros-iron-ament-lint-auto <!nocheck>, ros-iron-ament-lint-common <!nocheck>, ros-iron-diagnostic-msgs, ros-iron-diagnostic-updater, ros-iron-rclcpp, ros-iron-sensor-msgs, ros-iron-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-iron-joy-linux
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-iron-diagnostic-msgs, ros-iron-diagnostic-updater, ros-iron-rclcpp, ros-iron-sensor-msgs, ros-iron-ros-workspace
Description: ROS2 driver for a generic Linux joystick.
 Will contain a MacOS and Windows version later. The joy package contains joy_node, a node that interfaces a generic Linux joystick to ROS2. This node publishes a &quot;Joy&quot; message, which contains the current state of each one of the joystick's buttons and axes.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-joy-linux//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
